AppTitle "SpeakNum"

Global Zero = LoadSound("Zero.ogg")
Global One = LoadSound("One.ogg")
Global Two = LoadSound("Two.ogg")
Global Three = LoadSound("Three.ogg")
Global Four = LoadSound("Four.ogg")
Global Five = LoadSound("Five.ogg")
Global Six = LoadSound("Six.ogg")
Global Seven = LoadSound("Seven.ogg")
Global Eight = LoadSound("Eight.ogg")
Global Nine = LoadSound("Nine.ogg")
Global Ten = LoadSound("Ten.ogg")
Global Eleven = LoadSound("Eleven.ogg")
Global Twelve = LoadSound("Twelve.ogg")
Global Thirteen = LoadSound("Thirteen.ogg")
Global Fourteen = LoadSound("Fourteen.ogg")
Global Fifteen = LoadSound("Fifteen.ogg")
Global Teen = LoadSound("Teen.ogg")
Global Twenty = LoadSound("Twenty.ogg")
Global Thirty = LoadSound("Thirty.ogg")
Global Fourty = LoadSound("Fourty.ogg")
Global Fifty = LoadSound("Fifty.ogg")
Global Sixty = LoadSound("Sixty.ogg")
Global Seventy = LoadSound("Seventy.ogg")
Global Eighty = LoadSound("Eighty.ogg")
Global Ninety = LoadSound("Ninety.ogg")
Global Hundred = LoadSound("Hundred.ogg")
Global Thousand = LoadSound("Thousand.ogg")
Global Million = LoadSound("Million.ogg")
Global CommaSound = LoadSound("Comma.ogg")

ParseArg()
End

Function ParseArg()
	Local L$ = CommandLine()
	While(Len(L$) > 0)
		Local Comma = Instr(L$, ",")
		If Comma = 0 Then
			DebugLog("Using: "+L)
			Segment(L)
			L = ""
		Else
			DebugLog("Using: "+Left(L, Comma-1))
			DebugLog("Left: "+Right(L, Len(L)-Comma))
			Segment(Left(L, Comma-1))
			L = Right(L, Len(L)-Comma)
			
			Local Channel = PlaySound(CommaSound)
			While(ChannelPlaying(Channel))
			Wend
		End If
	Wend
End Function

Function Segment(Seg$)
	Local Minus = Instr(Seg, "-")
	If Minus = 0 Then
		GiveIt(Int(Seg))
	Else
		Local Frst$ = Left(Seg, Minus-1)
		Local Scnd$ = Right(Seg, Len(Seg)-Minus)
		Local Start = Int(Frst)
		Local Finish = Int(Scnd)
		Local SayComma = False
		While(Finish >= Start)
			If SayComma Then
				Local Channel = PlaySound(CommaSound)
				While(ChannelPlaying(Channel))
				Wend
			End If
			GiveIt(Start)
			Start = Start + 1
			SayComma = True
		Wend
	End If
End Function

Function GiveIt(Number)
	Local Channel
	
	If Number < 0 Or Number > 999999999 Then
		Return
	Else If Number = 0 Then
		Channel = PlaySound(Zero)
		While(ChannelPlaying(Channel))
		Wend
		Return
	End If
	
	Local Hundreds = Number Mod 1000
	Number = Number/1000
	Local Thousands = Number Mod 1000
	Number = Number/1000
	Local Millions = Number Mod 1000

	If Millions > 0 Then
		SayHundreds(Millions)
		Channel = PlaySound(Million)
		While(ChannelPlaying(Channel))
		Wend
	End If	
	
	If Thousands > 0 Then
		SayHundreds(Thousands)
		Channel = PlaySound(Thousand)
		While(ChannelPlaying(Channel))
		Wend
	End If
	
	If Hundreds > 0 Then
		SayHundreds(Hundreds)
	End If
End Function

Function SayHundreds(Number)
	If Number < 0 Or Number > 999 Then
		Return
	End If
	
	Local Ones = Number Mod 10
	Number = Number/10
	Local Tens = Number Mod 10
	Number = Number/10
	Local Hundreds = Number Mod 10
	
	Local Channel
	
	If Hundreds > 0 Then
		Select Hundreds
			Case 1
				Channel = PlaySound(One)
			Case 2
				Channel = PlaySound(Two)
			Case 3
				Channel = PlaySound(Three)
			Case 4
				Channel = PlaySound(Four)
			Case 5
				Channel = PlaySound(Five)
			Case 6
				Channel = PlaySound(Six)
			Case 7
				Channel = PlaySound(Seven)
			Case 8
				Channel = PlaySound(Eight)
			Case 9
				Channel = PlaySound(Nine)
		End Select
		While(ChannelPlaying(Channel))
		Wend
		Channel = PlaySound(Hundred)
		While(ChannelPlaying(Channel))
		Wend
	End If
	
	If Tens > 0 Then
		Select Tens
			Case 1
				Local Temp = (Tens*10)+Ones
				Select Temp
					Case 10
						Channel = PlaySound(Ten)
					Case 11
						Channel = PlaySound(Eleven)
					Case 12
						Channel = PlaySound(Twelve)
					Case 13
						Channel = PlaySound(Thirteen)
					Case 14
						Channel = PlaySound(Fourteen)
					Case 15
						Channel = PlaySound(Fifteen)
					Default
						Select Ones
							Case 6
								Channel = PlaySound(Six)
							Case 7
								Channel = PlaySound(Seven)
							Case 8
								Channel = PlaySound(Eight)
							Case 9
								Channel = PlaySound(Nine)
						End Select
						While(ChannelPlaying(Channel))
						Wend
						Channel = PlaySound(Teen)
				End Select
			Case 2
				Channel = PlaySound(Twenty)
			Case 3
				Channel = PlaySound(Thirty)
			Case 4
				Channel = PlaySound(Fourty)
			Case 5
				Channel = PlaySound(Fifty)
			Case 6
				Channel = PlaySound(Sixty)
			Case 7
				Channel = PlaySound(Seventy)
			Case 8
				Channel = PlaySound(Eighty)
			Case 9
				Channel = PlaySound(Ninety)
		End Select
		While(ChannelPlaying(Channel))
		Wend
	End If
	
	If Tens <> 1 And Ones > 0 Then
		Select Ones
			Case 1
				Channel = PlaySound(One)
			Case 2
				Channel = PlaySound(Two)
			Case 3
				Channel = PlaySound(Three)
			Case 4
				Channel = PlaySound(Four)
			Case 5
				Channel = PlaySound(Five)
			Case 6
				Channel = PlaySound(Six)
			Case 7
				Channel = PlaySound(Seven)
			Case 8
				Channel = PlaySound(Eight)
			Case 9
				Channel = PlaySound(Nine)
		End Select
		While(ChannelPlaying(Channel))
		Wend
	End If
End Function